# QPaintEngine Class Reference

### [com.trolltech.qt.gui package]

### Constructor

- void QPaintEngine(PaintEngineFeatures features)

### Constructor Properties

- prototype: The QPaintEngine prototype object
- OddEvenMode
- WindingMode
- ConvexMode
- PolylineMode
- PolygonDrawMode( value )
- X11
- Windows
- QuickDraw
- CoreGraphics
- MacPrinter
- QWindowSystem
- PostScript
- OpenGL
- Picture
- SVG
- Raster
- Direct3D
- Pdf
- OpenVG
- OpenGL2
- PaintBuffer
- Blitter
- User = 50
- MaxUser = 100
- Type( value )
- AllFeatures = 0xffffffff
- PrimitiveTransform = 0x00000001
- PatternTransform = 0x00000002
- PixmapTransform = 0x00000004
- PatternBrush = 0x00000008
- LinearGradientFill = 0x00000010
- RadialGradientFill = 0x00000020
- ConicalGradientFill = 0x00000040
- AlphaBlend = 0x00000080
- PorterDuff = 0x00000100
- PainterPaths = 0x00000200
- Antialiasing = 0x00000400
- BrushStroke = 0x00000800
- ConstantOpacity = 0x00001000
- MaskedBrush = 0x00002000
- PerspectiveTransform = 0x00004000
- BlendModes = 0x00008000
- ObjectBoundingModeGradients = 0x00010000
- RasterOpModes = 0x00020000
- PaintOutsidePaintEvent = 0x20000000
- PaintEngineFeature( value )
- PaintEngineFeatures( value1, value2, ... )
- DirtyPen = 0x0001
- DirtyBrush = 0x0002
- DirtyBrushOrigin = 0x0004
- DirtyFont = 0x0008
- DirtyBackground = 0x0010
- DirtyBackgroundMode = 0x0020
- DirtyTransform = 0x0040
- DirtyClipRegion = 0x0080
- DirtyClipPath = 0x0100
- DirtyHints = 0x0200
- DirtyCompositionMode = 0x0400
- DirtyClipEnabled = 0x0800
- DirtyOpacity = 0x1000
- AllDirty = 0xffff
- DirtyFlag( value )
- DirtyFlags( value1, value2, ... )

### Prototype Object Properties

- bool begin(QPaintDevice pdev)
- void clearDirty(DirtyFlags df)
- QPoint coordinateOffset()
- void drawEllipse(QRect r)
- void drawImage(QRectF r, QImage pm, QRectF sr, ImageConversionFlags flags)
- void drawLines(QLine lines, int lineCount)
- void drawPath(QPainterPath path)
- void drawPixmap(QRectF r, QPixmap pm, QRectF sr)
- void drawPoints(QPoint points, int pointCount)
- void drawPolygon(QPoint points, int pointCount, PolygonDrawMode mode)
- void drawRects(QRect rects, int rectCount)
- void drawTextItem(QPointF p, QTextItem textItem)
- void drawTiledPixmap(QRectF r, QPixmap pixmap, QPointF s)
- bool end()
- bool hasFeature(PaintEngineFeatures feature)
- bool isActive()
- bool isExtended()
- QPaintDevice paintDevice()
- QPainter painter()
- void setActive(bool newState)
- void setDirty(DirtyFlags df)
- void setSystemClip(QRegion baseClip)
- void setSystemRect(QRect rect)
- void syncState()
- QRegion systemClip()
- QRect systemRect()
- bool testDirty(DirtyFlags df)
- Type type()
- void updateState(QPaintEngineState state)

### Instance Properties

QPaintEngine objects have no special properties beyond those inherited from the QPaintEngine prototype object.